"use strict";

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require("classnames");

var _classnames2 = _interopRequireDefault(_classnames);

var _lib = require("../../lib");

require("./Drawer.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Drawer = (_temp = _class = function (_CoreComponent) {
  _inherits(Drawer, _CoreComponent);

  function Drawer(props) {
    _classCallCheck(this, Drawer);

    var _this = _possibleConstructorReturn(this, _CoreComponent.call(this, props));

    _this.ensureAttachment = function () {
      if (_this.node) {
        var attachment = _this.state.attachment;

        var _this$node$getBoundin = _this.node.getBoundingClientRect(),
            width = _this$node$getBoundin.width,
            height = _this$node$getBoundin.height,
            top = _this$node$getBoundin.top,
            left = _this$node$getBoundin.left,
            bottom = _this$node$getBoundin.bottom,
            right = _this$node$getBoundin.right;

        var _UIGlobals$getScreenD = _lib.UIGlobals.getScreenDimensions(),
            screenHeight = _UIGlobals$getScreenD.height,
            screenWidth = _UIGlobals$getScreenD.width;

        var newAttach = attachment;
        if (height > screenHeight / 2) {
          newAttach = left > screenWidth / 2 ? "right" : "left";
        } else {
          newAttach = top > screenHeight / 2 ? "bottom" : "top";
        }
        if (newAttach !== attachment) {
          _this.setState({ attachment: newAttach });
        }
      }
    };

    _this.useParentNode = true;
    _this.state = {
      attachment: props.attach
    };
    return _this;
  }

  Drawer.prototype.componentDidMount = function componentDidMount() {
    this.ensureAttachment();
  };

  Drawer.prototype.render = function render() {
    var _classes,
        _this2 = this;

    var _getValidProps = (0, _lib.getValidProps)(this.props),
        Component = _getValidProps.renderAs,
        uiclass = _getValidProps.uiclass,
        active = _getValidProps.active,
        color = _getValidProps.color,
        colorStyle = _getValidProps.colorStyle,
        uuid = _getValidProps.uuid,
        attach = _getValidProps.attach,
        icon = _getValidProps.icon,
        disabled = _getValidProps.disabled,
        minimizable = _getValidProps.minimizable,
        children = _getValidProps.children,
        props = _getValidProps.props;

    this.ensureAttachment();
    var attachment = this.state.attachment;


    var classes = (_classes = {}, _classes["ui-drawer-" + attachment] = attachment, _classes.active = active, _classes.minimized = !active && minimizable, _classes);
    if (!_lodash2.default.isNil(color)) {
      var nohover = String(color).indexOf("!") !== -1;
      var cleanColor = String(color).replace("!", "");
      var colorClass = "ui-" + cleanColor;
      if (!_lodash2.default.isNil(colorStyle)) {
        colorClass += "-" + colorStyle;
      }
      if (nohover) {
        colorClass += "-no-hover";
      }
      classes[colorClass] = true;
    }

    return _react2.default.createElement(
      Component,
      _extends({}, props, {
        className: (0, _classnames2.default)("ui-drawer", classes),
        ref: this.onSetRef
      }),
      _react2.default.createElement(
        "div",
        { className: "ui-drawer-content" },
        _react2.default.Children.map(children, function (child) {
          return _react2.default.createElement(
            "div",
            { className: "ui-drawer-row" },
            _this2.renderChild(child, {
              disabled: disabled,
              uiclass: uiclass,
              active: active
            })
          );
        })
      )
    );
  };

  return Drawer;
}(_lib.CoreComponent), _class.propTypes = (0, _lib.getCorePropTypes)({
  minimizable: "bool",
  defaultOpen: "bool",
  icon: "string"
}), _class.defaultProps = (0, _lib.getCorePropDefaults)({
  uirole: _lib.ROLE.DRAWER,
  minimizable: true,
  defaultOpen: false,
  icon: "fa fa-bars",
  attach: "left"
}), _temp);
exports.default = Drawer;
module.exports = exports["default"];